      PROGRAM SD_GETINFO 

      implicit none

      integer*4 sd_id, sds_id, num_type
      integer*4 n_datasets, n_file_attrs, index, rank
      integer istat, attributes
      integer sfstart, sffinfo, sfselect, sfginfo
      integer sfendacc, sfend

C     DFACC_RDONLY is defined in hdf.h. MAX_NC_NAME and MAX_VAR_DIMS
C     are defined in netcdf.h.
      integer*4 DFACC_RDONLY, MAX_VAR_DIMS
      parameter (DFACC_RDONLY = 1, MAX_VAR_DIMS = 32)

      integer*4 dim_sizes(MAX_VAR_DIMS)
      character name *(60)

C     Open the file and initiate the SD interface.
      sd_id = sfstart('sd.hdf', DFACC_RDONLY)
      print*,'sfstart returns sd_id: ', sd_id

C     Determine the contents of the file.
      istat = sffinfo(sd_id, n_datasets, n_file_attrs)
      print*,'sffinfo returns: ', istat 

C     Access and print the names of every data set in the file.
      do 10 index = 0, n_datasets - 1
       sds_id = sfselect(sd_id, index)
       print*,'sfselect returns sds_id: ', sds_id
       istat = sfginfo(sds_id, name, rank, dim_sizes, num_type, 
     +                 attributes)
       print*,'sfginfo returns: ', istat
       write(*,*) 'name = ', name
       write(*,*) 'rank = ', rank
       write(*,*) 'number of attributes = ', attributes
       istat = sfendacc(sds_id)
       print*,'sfendacc returns: ', istat
10    continue

C     Terminate access to the SD interface and close the file.
      istat = sfend(sd_id)
      print*,'sfend returns: ', istat

      end


