#include "hdf.h"

main( ) 
{
    int32 sd_id, sds_id, n_datasets, n_file_attrs, sds_idx;
    int32 dim_sizes[MAX_VAR_DIMS], dimid0, dimid1;
    int32 rank, num_type, attributes, istat;
    char name[MAX_NC_NAME];
    int16 scale0[10] = {0,1,2,3,4,5,6,7,8,9};
    int16 scale1[5] = {0,1,2,3,4};

    /* Open the file and initiate the SD interface. */
    sd_id = SDstart("sd.hdf", DFACC_RDWR);
    printf ("SDstart returns sd_id: %i\n", sd_id);

    sds_idx = SDnametoindex (sd_id, "data1");
    printf ("SDnametoindex returns sds_idx: %i\n", sds_idx);
    sds_id = SDselect(sd_id, sds_idx);
    printf ("SDselect returns sds_id: %i\n", sds_id);
    istat = SDgetinfo(sds_id, name, &rank, dim_sizes,  \
                      &num_type, &attributes);
    printf ("SDgetinfo returns: %i\n", istat);
    printf ("Dimension 0 Size: %i\n", dim_sizes[0]);
    printf ("Dimension 1 Size: %i\n", dim_sizes[1]);

    dimid0 = SDgetdimid (sds_id, 0);
    printf ("SDgetdimid returns dimid0: %i\n", dimid0);
    istat = SDsetdimscale (dimid0, dim_sizes[0], num_type, scale0);
    printf ("SDsetdimscale returns: %i\n", istat);
    dimid1 = SDgetdimid (sds_id, 1);
    printf ("SDgetdimid returns dimid1: %i\n", dimid1);
    istat = SDsetdimscale (dimid1, dim_sizes[1], num_type, scale1);
    printf ("SDsetdimscale returns: %i\n", istat);
    istat = SDendaccess(sds_id);
    printf ("SDendaccess returns: %i\n", istat);

    /* Terminate access to the SD interface and close the file. */
    istat = SDend(sd_id);
    printf ("SDend returns: %i\n", istat);

}


